function [M,D] = test1_matricesMD(x,y)

% funcion para test 1, tema 2, 521230, S2-2012

% construir matriz y parte derecha de sistema tridiagonal a resolver para
% encontrar spline cubico natural que interpola a los pares en x, y

n = length(x) - 1; 
h = x(2:n+1)-x(1:n);

b = h(2:n-1);

a = zeros(n-1,1);
d = zeros(n-1,1);
for k = 1:n-1
    a(k) = 2*(h(k)+h(k+1));
    d(k) = (y(k+2)-y(k+1))/h(k+1)-(y(k+1)-y(k))/h(k);
end
M = diag(a) + diag(b,1) + diag(b,-1);
D = 6*d;